//
//  YMCurve.m
//  MedicalBeauty
//
//  Created by 周磊 on 2018/10/23.
//  Copyright © 2018 刘超. All rights reserved.
//

#import "YMCurve.h"

@implementation YMCurve

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

- (instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        
            _controlPoint = CGPointMake(SCREEN_WIDTH / 2.0, 110);
        [self creatSubViewControlPoint:_controlPoint];

    }
    return self;
}

-(void)layoutSubviews{
    [super layoutSubviews];
    
    

}


- (void)creatSubViewControlPoint:(CGPoint)controlPoint {
    [self clearDisplayView];
    
    //贝塞尔曲线的画法是由起点、终点、控制点三个参数来画的，为了解释清楚这个点，我写了几行代码来解释它
    CGPoint startPoint   = CGPointMake(0, 0);
    CGPoint endPoint     = CGPointMake(SCREEN_WIDTH, 0);
    
    CALayer *layer1 = [CALayer layer];
    layer1.frame = CGRectMake(startPoint.x, startPoint.y, 5, 5);
    
    CALayer *layer2 = [CALayer layer];
    layer2.frame = CGRectMake(endPoint.x, endPoint.y, 5, 5);
    
    CALayer *layer3 = [CALayer layer];
    layer3.frame = CGRectMake(_controlPoint.x, _controlPoint.y, 5, 5);
    
    UIBezierPath *path = [UIBezierPath bezierPath];
    CAShapeLayer *layer = [CAShapeLayer layer];
    
    [path moveToPoint:startPoint];
    [path addQuadCurveToPoint:endPoint controlPoint:_controlPoint];
    
    layer.path = path.CGPath;
    layer.fillColor = YMColor(@"ff4040").CGColor;
    layer.strokeColor = YMColor(@"ff4040").CGColor;
    
    [self.layer addSublayer:layer];
    [self.layer addSublayer:layer1];
    [self.layer addSublayer:layer2];
    [self.layer addSublayer:layer3];
    
}

- (void)setControlPoint:(CGPoint)controlPoint{
    _controlPoint = controlPoint;
    [self creatSubViewControlPoint:_controlPoint];

    
}

- (void)clearDisplayView
{
    [self.layer.sublayers makeObjectsPerformSelector:@selector(removeFromSuperlayer)];
}

@end
